
CreateProcessWatcher proto

PWM_ADD_WND 		EQU WM_USER+100		; wParam = ptr PROCESS_WATCHER   lParam = 0
PWM_REMOVE_WND		EQU WM_USER+101		; wParam = hWnd					 lParam = 0
PWM_SET_INTERVAL	EQU WM_USER+102		; wParam = interval/ms			 lParam = 0

PROCESS_WATCHER struct
	hWnd			HWND	?
	uiMsg_start		UINT	?	; WM_USER + x
	uiMsg_stop		UINT	?	; WM_USER + y
	pNext			PVOID	?	; internal - do not use
PROCESS_WATCHER ends
PPROCESS_WATCHER typedef ptr PROCESS_WATCHER

pw_start macro
	invoke CreateProcessWatcher
	EXITM <eax>
endm

pw_add_window macro ddPWThreadId:req,_hWnd:req,msgStart:req,msgStop:req
	mov eax,alloc(SIZEOF PROCESS_WATCHER)
	m2m [eax].PROCESS_WATCHER.hWnd,_hWnd
	m2m [eax].PROCESS_WATCHER.uiMsg_start,msgStart
	m2m [eax].PROCESS_WATCHER.uiMsg_stop,msgStop
	invoke PostThreadMessage,ddPWThreadId,PWM_ADD_WND,eax,0	
endm

pw_remove_window macro ddPWThreadId:req,_hWnd:req
	invoke PostThreadMessage,ddPWThreadId,PWM_REMOVE_WND,_hWnd,0	
endm

pw_set_interval macro ddPWThreadId:req,interval:req
	invoke PostThreadMessage,ddPWThreadId,PWM_SET_INTERVAL,interval,0	
endm

pw_stop macro ddPWThreadId:req
	invoke PostThreadMessage,ddPWThreadId,WM_QUIT,0,0
endm