include masm32rt.inc

include PWL.inc
includelib PWL.lib

WM_PROCESS_START 	EQU WM_USER + 1
WM_PROCESS_STOP		EQU WM_USER + 2

.data?
	hInstance		HINSTANCE	?
	dwPWThreadID	DWORD		?
.code
main proc
LOCAL hThread:HANDLE
LOCAL msg:MSG
LOCAL wc:WNDCLASSEX
	
	mov hInstance,rv(GetModuleHandle,0)
	mov wc.hInstance,eax
	mov wc.cbSize,SIZEOF wc
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc,WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov wc.lpszClassName,chr$("WinClass32")
	mov wc.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wc.hIconSm,eax
	mov wc.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	mov wc.lpszMenuName,0
	mov wc.hbrBackground,COLOR_WINDOWFRAME
	invoke RegisterClassEx,ADDR wc
	mov edi,rv(CreateWindowEx,0,wc.lpszClassName,"process watcher1",WS_SYSMENU or WS_SIZEBOX or WS_VISIBLE or WS_MINIMIZEBOX or WS_MAXIMIZEBOX,0,0,300,400,0,0,hInstance,0)
	mov esi,rv(CreateWindowEx,0,wc.lpszClassName,"process watcher2",WS_SYSMENU or WS_SIZEBOX or WS_VISIBLE or WS_MINIMIZEBOX or WS_MAXIMIZEBOX,300,0,300,400,0,0,hInstance,0)
	
	mov dwPWThreadID,pw_start()
	pw_add_window dwPWThreadID,edi,WM_PROCESS_START,WM_PROCESS_STOP
	pw_add_window dwPWThreadID,esi,WM_PROCESS_START,WM_PROCESS_STOP
	
	.while 1
		invoke GetMessage,ADDR msg,0,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage,ADDR msg
		invoke DispatchMessage,ADDR msg		
	.endw

	exit
	
main endp

WndProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL sz[1024]:CHAR

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,0
	.elseif uMsg == WM_CREATE
		invoke SetWindowLong,hWnd,GWL_USERDATA,rv(CreateWindowEx,0,"LISTBOX",0,WS_CHILD or WS_VISIBLE,0,0,300,400,hWnd,0,hInstance,0)
	.elseif uMsg == WM_PROCESS_START
		mov ebx,rv(GetWindowLong,hWnd,GWL_USERDATA)
		mov sz[0],0
		invoke SendMessage,ebx,LB_ADDSTRING,0,cat$(ADDR sz[0],"start: ",str$(wParam),"   ",lParam)
		free lParam
	.elseif uMsg == WM_PROCESS_STOP
		mov ebx,rv(GetWindowLong,hWnd,GWL_USERDATA)
		mov sz[0],0
		invoke SendMessage,ebx,LB_ADDSTRING,0,cat$(ADDR sz[0],"stop:  ",str$(wParam),"   ",lParam)
		free lParam
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
	
WndProc endp
end main